<?php
/**
 * @copyright Copyright (c) 2016 https://FiloBludraji.wordpress.com
 */

namespace FiloBlu\ExtViSualMerchandiser\Model\Category;

use Magento\Catalog\Model\ResourceModel\Category\Collection;
use Magento\Catalog\Model\ResourceModel\Category\CollectionFactory;
use Magento\Framework\Data\OptionSourceInterface;
use Magento\Framework\Exception\LocalizedException;

/**
 * Class Categorylist
 * @package FiloBlu\ExtViSualMerchandiser\Model\Category
 */
class Categorylist implements OptionSourceInterface
{
    /**
     * @var CollectionFactory
     */
    protected $_categoryCollectionFactory;

    /**
     * Categorylist constructor.
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(
        CollectionFactory $collectionFactory
    )
    {
        $this->_categoryCollectionFactory = $collectionFactory;
    }

    /**
     * @param bool $addEmpty
     * @return array
     * @throws LocalizedException
     */
    public function toOptionArray($addEmpty = true)
    {
        /** @var Collection $collection */
        $collection = $this->_categoryCollectionFactory->create();

        $collection->addAttributeToSelect('name');

        $options = [];

        if ($addEmpty) {
            $options[] = [
                'label' => __('-- Please Select a Category --'),
                'value' => ''
            ];
        }
        foreach ($collection as $category) {
            $options[] = [
                'label' => '(id:' . $category->getId() . ') ' . $category->getName(),
                'value' => $category->getId()
            ];
        }

        return $options;
    }
}
