<?php

namespace FiloBlu\ExtViSualMerchandiser\Model\Config\Source;

use FiloBlu\ExtViSualMerchandiser\Helper\ConfigHelper;
use Magento\Framework\Data\OptionSourceInterface;

/**
 * Class Stocks
 * @package FiloBlu\ExtViSualMerchandiser\Model\Config\Source
 */
class Stocks implements OptionSourceInterface
{
    /**
     * @var ConfigHelper
     */
    private $configHelper;

    /**
     * Stocks constructor.
     * @param ConfigHelper $configHelper
     */
    public function __construct(ConfigHelper $configHelper)
    {
        $this->configHelper = $configHelper;
    }

    /**
     * @return array
     */
    public function toOptionArray()
    {
        $stocks = $this->configHelper->getAvailableStocks();
        $values = [];
        foreach ($stocks as $stockId => $stockName) {
            $values[] = [
                'label' => $stockName,
                'value' => $stockId,
            ];
        }

        return $values;
    }
}
